---
include:
  - remote: 'https://gitlab.com/op_so/projects/gitlab-ci-templates/-/raw/main/templates/lint.gitlab-ci.yml'
  - remote: 'https://gitlab.com/op_so/projects/gitlab-ci-templates/-/raw/main/templates/image-factory.gitlab-ci.yml'

variables:
  DOCKER_REGISTRY_IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
  DOCKER_DOCKERHUB_IMAGE_REPOSITORY: index.docker.io/jfxs/image-factory
  DOCKER_DOCKERHUB_RM_URL: jfxs/image-factory
  DOCKER_QUAY_IMAGE_REPOSITORY: quay.io/ifxs/image-factory
  DOCKER_QUAY_RM_URL: quay.io/ifxs/image-factory
  DOCKER_SBOM_SUBSET: "^cosign |^curl |^git |^jq |^skopeo |^syft |^github.com/go-task/task/v3 "
  IMAGE_DOCKER: docker:latest
  LINT_DOCKER: "true"
  TASKFILE_VERSION: .Taskfile-version.yml

stages:
  - lint
  - build-image
  - test-image
  - trigger-publish-image
  - publish-image

docker:build:
  image: $IMAGE_DOCKER
  before_script:
    - apk --no-cache add cosign jq skopeo syft
    - if ! [ -x "$(command -v task)" ]; then sh -c "$(wget -qO- https://taskfile.dev/install.sh)" -- -d -b /usr/local/bin; fi
    - task --version
    - if [ ! -f "$TASKFILE_VERSION" ]; then wget -q -O "$TASKFILE_VERSION" https://gitlab.com/op_so/task/task-templates/-/raw/main/Taskfile.d/version.yml; fi
    - DOCKER_BUILD_VERSION=$(task --taskfile "$TASKFILE_VERSION" get-docker-cli-version IMG="$IMAGE_DOCKER" CMD="docker --version")

sanity-test:amd64:
  image: $DOCKER_REGISTRY_IMAGE_TAG
  stage: test-image
  script:
    - docker --version
    - cosign version
    - git --version
    - jq --version
    - skopeo --version
    - syft --version
    - task --version
    - docker pushrm --help

sanity-test:arm64:
  extends: sanity-test:amd64
  tags:
    - arm64

sanity-test:version:
  image: $DOCKER_REGISTRY_IMAGE_TAG
  before_script:
    - if ! [ -x "$(command -v task)" ]; then sh -c "$(wget -qO- https://taskfile.dev/install.sh)" -- -d -b /usr/local/bin; fi
    - task --version
    - if [ ! -f "$TASKFILE_VERSION" ]; then wget -q -O "$TASKFILE_VERSION" https://gitlab.com/op_so/task/task-templates/-/raw/main/Taskfile.d/version.yml; fi
    - DOCKER_VERSION_CLI=$(task --taskfile "$TASKFILE_VERSION" get-docker-cli-version IMG="$DOCKER_REGISTRY_IMAGE_TAG" CMD="docker --version")

trigger:publish:
  image: $DOCKER_REGISTRY_IMAGE_TAG

publish:dockerhub:
  image: $DOCKER_REGISTRY_IMAGE_TAG

publish:quay:
  image: $DOCKER_REGISTRY_IMAGE_TAG
